﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Diagnostics;

namespace esl
{
    class PackageManagementRest
    {
        public static void main()
        {
            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Add("Authorization", "Basic " + Properties.Settings.Default.key);
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json");

            //retrieve package
            var response = httpClient.GetAsync(new Uri("https://sandbox.esignlive.com/api/packages/{packageId}")).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);

            //update package
            string json = "{\"due\":\"2017-02-13T21:18:40Z\",\"emailMessage\":\"new email message\",\"notarized\":true,\"settings\":{\"ceremony\":{\"inPerson\":false,\"declineButton\":true,\"declineReasons\":[\"new decline reason #1\",\"new decline reason #2\",\"new decline reason #3\"],\"disableDeclineOther\":false,\"disableDownloadForUncompletedPackage\":false,\"disableFirstInPersonAffidavit\":false,\"disableInPersonAffidavit\":false,\"disableOptOutOther\":false,\"disableSecondInPersonAffidavit\":false,\"documentToolbarOptions\":{\"downloadButton\":false},\"events\":{\"complete\":{\"dialog\":false,\"redirect\":\"\"}},\"handOver\":{\"href\":\"http://www.new.ca\",\"title\":\"new hand over link tool tip\",\"text\":\"new hand over link text\"},\"hideCaptureText\":true,\"hideLanguageDropdown\":false,\"hidePackageOwnerInPerson\":false,\"hideWatermark\":true,\"maxAuthFailsAllowed\":3,\"optOutButton\":false,\"optOutReasons\":[\"new opt out reason #1\",\"new opt out reason #2\",\"new opt out reason #3\"],\"layout\":{\"brandingBar\":{\"logo\":{\"src\":\"new logo image source\",\"link\":\"new logo image link\"}},\"footer\":{},\"iframe\":false,\"navigator\":false,\"header\":{\"feedback\":true,\"breadcrumbs\":false,\"titleBar\":{\"progressBar\":false,\"title\":false},\"globalActions\":{\"confirm\":false,\"download\":false,\"hideEvidenceSummary\":true,\"saveAsLayout\":false},\"globalNavigation\":false,\"sessionBar\":false}},\"style\":null}},\"description\":\"\",\"autocomplete\":false,\"visibility\":\"ACCOUNT\",\"status\":\"DRAFT\",\"type\":\"PACKAGE\",\"roles\":[{\"reassign\":false,\"locked\":false,\"index\":0,\"type\":\"SENDER\",\"signers\":[{\"title\":null,\"auth\":{\"challenges\":[],\"scheme\":\"NONE\"},\"address\":null,\"phone\":\"\",\"firstName\":\"Haris\",\"lastName\":\"Haidary\",\"email\":\"haris.haidary@gmail.com\",\"company\":\"eSignLive\",\"language\":\"fr\",\"name\":\"\"}],\"name\":\"Owner\"}],\"language\":\"fr\",\"name\":\"new package name\",\"bulkSendable\":false}";
            StringContent jsonContent = new StringContent(json, Encoding.UTF8, "application/json");

            response = httpClient.PutAsync(new Uri("https://sandbox.esignlive.com/api/packages/{packageId}"), jsonContent).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);

            //delete package
            response = httpClient.DeleteAsync(new Uri("https://sandbox.esignlive.com/api/packages/{packageId}")).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
